<?php
/* Autor...:  */
/* Esquema.: VTA_FormaPago.xml */
/* Generado: 2021-09-16 05:34:52 */

/* Metodos de acceso a los campos de la tabla VTA_FormaPago */
abstract class BaseVTA_FormaPagoBN
{
    /* Campos de la tabla */
    private $s_IdFormaPago;    // IdFormaPago: ( no definido )
    private $s_DescripcionLocal;    // DescripcionLocal: ( no definido )
    private $s_Codigo;    // Codigo: ( no definido )
    private $s_CodigoSunat;    // CodigoSunat: ( no definido )
    private $s_ContadoFlag;    // ContadoFlag: ( no definido )
    private $i_Dias;    // Dias: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdFormaPago */
    public function setIdFormaPago( $s_IdFormaPago )
    {
        $this->s_IdFormaPago = $s_IdFormaPago;
    }

    /* Obtiene el valor del campo IdFormaPago */
    public function getIdFormaPago()
    {
        return $this->s_IdFormaPago;
    }

    /* Establece el valor del campo DescripcionLocal */
    public function setDescripcionLocal( $s_DescripcionLocal )
    {
        $this->s_DescripcionLocal = $s_DescripcionLocal;
    }

    /* Obtiene el valor del campo DescripcionLocal */
    public function getDescripcionLocal()
    {
        return $this->s_DescripcionLocal;
    }

    /* Establece el valor del campo Codigo */
    public function setCodigo( $s_Codigo )
    {
        $this->s_Codigo = $s_Codigo;
    }

    /* Obtiene el valor del campo Codigo */
    public function getCodigo()
    {
        return $this->s_Codigo;
    }

    /* Establece el valor del campo CodigoSunat */
    public function setCodigoSunat( $s_CodigoSunat )
    {
        $this->s_CodigoSunat = $s_CodigoSunat;
    }

    /* Obtiene el valor del campo CodigoSunat */
    public function getCodigoSunat()
    {
        return $this->s_CodigoSunat;
    }

    /* Establece el valor del campo ContadoFlag */
    public function setContadoFlag( $s_ContadoFlag )
    {
        $this->s_ContadoFlag = $s_ContadoFlag;
    }

    /* Obtiene el valor del campo ContadoFlag */
    public function getContadoFlag()
    {
        return $this->s_ContadoFlag;
    }

    /* Establece el valor del campo Dias */
    public function setDias( $i_Dias )
    {
        $this->i_Dias = $i_Dias;
    }

    /* Obtiene el valor del campo Dias */
    public function getDias()
    {
        return $this->i_Dias;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdFormaPago' => $this->getIdFormaPago(),
            'DescripcionLocal' => $this->getDescripcionLocal(),
            'Codigo' => $this->getCodigo(),
            'CodigoSunat' => $this->getCodigoSunat(),
            'ContadoFlag' => $this->getContadoFlag(),
            'Dias' => $this->getDias(),
            'Estado' => $this->getEstado(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto VTA_FormaPagoBN desde un RecordSet */
    public static function retrieveByRs( $o_VTA_FormaPagoRs )
    {
        $o_VTA_FormaPagoBN = new VTA_FormaPagoBN();
        $o_VTA_FormaPagoBN->setIdFormaPago( $o_VTA_FormaPagoRs[ "IdFormaPago" ] );
        $o_VTA_FormaPagoBN->setDescripcionLocal( $o_VTA_FormaPagoRs[ "DescripcionLocal" ] );
        $o_VTA_FormaPagoBN->setCodigo( $o_VTA_FormaPagoRs[ "Codigo" ] );
        $o_VTA_FormaPagoBN->setCodigoSunat( $o_VTA_FormaPagoRs[ "CodigoSunat" ] );
        $o_VTA_FormaPagoBN->setContadoFlag( $o_VTA_FormaPagoRs[ "ContadoFlag" ] );
        $o_VTA_FormaPagoBN->setDias( ( integer ) $o_VTA_FormaPagoRs[ "Dias" ] );
        $o_VTA_FormaPagoBN->setEstado( $o_VTA_FormaPagoRs[ "Estado" ] );
        $o_VTA_FormaPagoBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_VTA_FormaPagoRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_VTA_FormaPagoBN->setUsuarioCreacion( $o_VTA_FormaPagoRs[ "UsuarioCreacion" ] );
        $o_VTA_FormaPagoBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_VTA_FormaPagoRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_VTA_FormaPagoBN->setUsuarioModificacion( $o_VTA_FormaPagoRs[ "UsuarioModificacion" ] );
        return $o_VTA_FormaPagoBN;
    }
}
?>